#let s_topic_list = state("topics", ())
#let s_topic = state("topic", 0)

#let init-presentation(topics: ()) = {
  // validation hell :3
  if type(topics) != "array" {
    panic("Expected array of topics.")
  }
  if not (
    topics.all(it => type(it) == "string" or type(it) == content)
      or topics.all(it => type(it) == "color")
      or topics.all(it => (
        it.len() == 2
          and (
            (type(it.first()) == "string" or type(it.first() == "content")) and type(it.last()) == "color"
          )
      ))
  ) {
    // TODO: more specific error, telling the exact wrong indices
    panic("topics expected a uniform array of: ", "string | content", "color", "(string | content, color)")
  }

  s_topic_list.update(topics)
}

#let slide(paper: "presentation-16-9", body) = [
  #page(paper: paper)[
    #body
  ] <slide>
]
